[r363]: branches / 0.71 / Makefile.PL Maximize Restore History

Download this file

Makefile.PL    245 lines (212 with data), 8.8 kB

  1
  2
  3
  4
  5
  6
  7
  8
  9
 10
 11
 12
 13
 14
 15
 16
 17
 18
 19
 20
 21
 22
 23
 24
 25
 26
 27
 28
 29
 30
 31
 32
 33
 34
 35
 36
 37
 38
 39
 40
 41
 42
 43
 44
 45
 46
 47
 48
 49
 50
 51
 52
 53
 54
 55
 56
 57
 58
 59
 60
 61
 62
 63
 64
 65
 66
 67
 68
 69
 70
 71
 72
 73
 74
 75
 76
 77
 78
 79
 80
 81
 82
 83
 84
 85
 86
 87
 88
 89
 90
 91
 92
 93
 94
 95
 96
 97
 98
 99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221
222
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.
use 5.006; #weak references require perl 5.6
use strict;
use ExtUtils::MakeMaker;
use diagnostics;
my @PREREQS = (
# ["<feature>","<installed module>",<dependency hash>,<install by default, 2=always>];
[
"Core Package",
"SOAP::Lite",
{
"Test::More" => 0,
"XML::Parser" => "2.23",
"MIME::Base64" => 0,
"URI" => 0,
"Scalar::Util" => 0,
"Task::Weaken" => 0, #to be sure than weaken works (Scalar::Util has XS part)
"constant" => 0, #don't force people to upgrade
},
2
],
[
"Client HTTP support",
"SOAP::Transport::HTTP",
{
"LWP::UserAgent" => 0
},
2
],
["Client HTTPS support","SOAP::Transport::HTTPS::Client",{"Crypt::SSLeay" => 0},0],
["Client SMTP/sendmail support","SOAP::Transport::MAILTO::Client",{"MIME::Lite" => 0},1],
["Client FTP support","SOAP::Transport::FTP::Client",{"SOAP::Transport::FTP" => 0.711},0],
["Standalone HTTP server","SOAP::Transport::HTTP::Daemon",{"HTTP::Daemon" => 0},1],
["Apache/mod_perl server","SOAP::Transport::HTTP::Apache",{"Apache" => 0},0],
["FastCGI server","SOAP::Transport::HTTP::FCGI",{"FCGI" => 0},0],
["POP3 server","SOAP::Transport::POP3::Server",{"Net::POP3" => 0,"MIME::Parser" => 0},1],
["IO server","SOAP::Transport::IO::Server",{"IO::File" => 0},0],
["MQ transport support","SOAP::Transport::MQ",{"SOAP::Transport::MQ" => 0.712},1],
["JABBER transport support","SOAP::Transport::JABBER",{"SOAP::Transport::JABBER" => 0.711},0],
["MIME messages","SOAP::Packager::MIME",{"MIME::Parser" => 0},1],
["DIME messages","SOAP::Packager::DIME",{"IO::Scalar" => "2.105", "DIME::Tools" => 0.03, "Data::UUID" => "0.11"},0],
["SSL Support for TCP Transport","SOAP::Transport::TCP",{"IO::Socket::SSL" => 0},0],
["Compression support for HTTP","SOAP::Transport::HTTP",{"Compress::Zlib" => 0},0],
["MIME interoperability w/ Axis","SOAP::Lite",{"MIME::Parser" => "6.106"},0],
);
use Getopt::Long;
my $helptext = <<EOI;
Usage: perl Makefile.PL <options>
Possible options are:
--noprompt Disable interactive dialog
--alltests Perform extra testing (Has no effect any more)
--help, -? Display this help text
[Do not] install prerequisites for appropriate module:
EOI
# Create config parameters using module names and expand help text
# We will create a hash (%config) that has each module => (1|0) for install
my(%options, %config, %has_module_cache);
# Initialize the prereq table and all help text
foreach my $prereq (@PREREQS) {
my ($feature,$dep,$modules,$default) = @$prereq;
next unless $dep ne "";
$prereq->[3] = has_all_modules($modules) unless $prereq->[3] == 2;
my $module = do { $dep =~ s/::/-/g; $dep };
my $shortcut = do { (my $t = $module) =~ s/SOAP-(?:Transport-)?//; $t };
$config{$dep} = has_all_modules($modules);
$options{"install-$dep|$shortcut!"} = \$config{$dep};
$helptext .= sprintf " --[no]install-%-28s --[no]%s\n", $dep, $shortcut;
}
use vars qw($noprompt $alltests $help $intro);
#my ($noprompt,$alltests,$help);
GetOptions (
"noprompt" => \$noprompt,
"alltests" => \$alltests,
"help|?" => \$help,
);
# don't prompt when run on a smoke test system.
# See http://cpantest.grango.org/wiki/CPANAuthorNotes
# Thanks to Andreas J Koenig && all CPAN testers !
$noprompt++ if $ENV{AUTOMATED_TESTING};
$help and print($helptext), exit;
$intro = <<EOI;
We are about to install SOAP::Lite and for your convenience will provide
you with list of modules and prerequisites, so you'll be able to choose
only modules you need for your configuration.
XMLRPC::Lite, UDDI::Lite, and XML::Parser::Lite are included by default.
Installed transports can be used for both SOAP::Lite and XMLRPC::Lite.
EOI
if ($noprompt) {
print "These are the modules that will get installed:\n\n";
} else {
ExtUtils::MakeMaker::prompt($intro . "Press <enter> to see the detailed list.");
}
# This hash will contain a list of all perl modules we would like to
# explicitly depend upon in our Makefile
my %prereqs;
my $proceed = 0;
do {
print "\n".generate_prereq_table()."\n";
# Ask the user if this is the configuration they desire
if ($noprompt) {
$proceed = 1;
} else {
$proceed = ExtUtils::MakeMaker::prompt("Do you want to proceed with this configuration?" => 'yes') =~ /^\s*y/i;
}
# Loop through each prerequisite and ask the user if they wish to
# install it or not - reset prereqs, cause they change each time
%prereqs = ();
for my $prereq (@PREREQS) {
my ($feature,$dep,$modules,$default) = @$prereq;
next unless $dep ne "";
unless ($proceed || $prereq->[3] == 2) { # need to use $prereq, because we modify actual value
$prereq->[3] = (ExtUtils::MakeMaker::prompt("Do you plan to use ${feature}?" => ($prereq->[3] ? 'yes' : 'no')) =~ /^\s*(y)/i);
}
(%prereqs = (%prereqs, map { $_,$modules->{$_} } keys %$modules)) if $prereq->[3];
}
} while (!$proceed);
# Old way of selecting tests - replaced by extended test suite in
# subdirectories...
# my $tests = join ' ', glob ($noncoretests ? 't/*.t' : 't/0*.t');
# Additional tests require Test::More
# only run noncoretests if we have Test::More
my $noncoretests;
if (eval { require Test::More; }) {
$noncoretests++;
}
my $tests;
if ($noncoretests) {
my @test_from = ();
require File::Find;
File::Find::find(sub {
return if -d $_;
return if $_ !~m{\.t$}x;
return if $File::Find::dir=~m{\bCVS\b};
return if $File::Find::dir=~m{\b\.svn\b};
return if $_=~m{^[1-9]}x;
push @test_from, $File::Find::name;
}, 't/'
);
$tests = join ' ' , @test_from;
}
else {
$tests = join ' ', glob ('t/0*.t t/*xmlparserlite.t t/*loopback.t');
}
ExtUtils::MakeMaker::WriteMakefile(
'NAME' => 'SOAP::Lite',
'AUTHOR' => 'Pavel Kulchenko, Randy J Ray, Byrne Reese, Martin Kutter (MKUTTER@cpan.org)',
'LICENSE' => 'perl',
'VERSION_FROM' => 'lib/SOAP/Lite.pm',
'ABSTRACT_FROM' => 'lib/SOAP/Lite.pm',
'PREREQ_PM' => {
%prereqs
},
'EXE_FILES' => ['bin/SOAPsh.pl', 'bin/XMLRPCsh.pl', 'bin/stubmaker.pl'],
test => {TESTS => $tests},
($ExtUtils::MakeMaker::VERSION ge '6.48'?
(MIN_PERL_VERSION => 5.006,
META_MERGE => {
resources=> {
repository => 'https://soaplite.svn.sourceforge.net/svnroot/soaplite/branches/0.71',
},
keywords => ['SOAP','SOAP client','SOAP server'],
bugtracker => 'https://sourceforge.net/tracker/?group_id=66000&atid=513017',
},
) : ()),
);
######################################################
# Supporting subroutines
######################################################
# Maintains a cache of what 3rd party modules you have
# installed
sub has_module {
my ($mod, $version) = @_;
$version ||= '';
# use "require Foo; Exporter::require_version('Foo' => 1)" instead of
# obvious "use Foo 1". The later doesn't work with MIME::Parser
# wonder why? --PK
return ($has_module_cache{"$mod$version"}
||= eval("require $mod; Exporter::require_version('$mod', $version) if ($version); 1"));
}
# Return 1 if all modules contained in the inputed array
# are installed, 0 otherwise
sub has_all_modules {
my ($mods) = @_;
foreach my $mod (keys %$mods) {
return 0 if !has_module($mod, $mods->{$mod});
}
return 1;
}
# Print a single prerequisite to the screen
sub generate_prereq {
my ($feature,$dep,$modules,$install) = @_;
my $i = 0;
my $buf = "";
foreach my $module (keys %$modules) {
my $detected = (has_module($module, $modules->{$module}) ? "*" : " ");
$buf .= sprintf("%-29s [%s] %-24s %-8s\n",($i++ ? "" : $feature),$detected,$module . ($modules->{$module} ? " (v$modules->{$module})" : ""),($i == 1 ? ($install ? ($install == 2 ? "always" : "[ yes ]") : "[ no ]") : ""));
}
return $buf;
}
# Print the entire prerequisites table
sub generate_prereq_table {
my $buf = sprintf("%-29s %-28s %-8s\n","Feature","Prerequisites","Install?");
$buf .= sprintf("%s %s %s\n","-" x 29,"-" x 28,"-" x 8);
foreach my $pre (@PREREQS) {
my ($feature,$dep,$modules,$default) = @{$pre};
$buf .= generate_prereq(@{$pre});
}
$buf .= "--- An asterix '[*]' indicates if the module is currently installed.\n";
return $buf;
}
1;